#include "main.h"

void clientConstraint(float *weight, float *volume, float *price)
{
	/*
	Saisie des contraintes du client.
	*/
	printf("Entrez la charge maximale de votre véhicule en kilogrammes: ");
	scanf("%f", weight);
	while (*weight < 0)
	{
		printf("Erreur, le poids doit être positif, entrez la charge maximale de votre véhicule en kilogrammes: ");
		scanf("%f", weight);
	}

	printf("Entrez le volume du coffre de votre véhicule en mètres cubes: ");
	scanf("%f", volume);
	while (*volume < 0)
	{
		printf("Erreur: le volume doit être positif, entrez le volume du coffre de votre véhicule en mètres cubes: ");
		scanf("%f", volume);
	}

	printf("Entrez votre budget maximum ou -1 si vous n'en avait pas: ");
	scanf("%f", price);
	while (*price < 0 || *price != -1)
	{
		printf("Erreur: le prix doit être positif, entrez votre budget maximum ou -1 si vous n'en avait pas: ");
		scanf("%f", price);
	}
}

int constraintExceeded(float weightConstraint, float volumeConstraint, float *priceConstraint, float tabWeight[], float tabVolume[], float tabUnitPrice[], int tabQuantity[], int tlog, float *cagnotte)
{
	float totalWeight = 0, totalVolume = 0, totalPrice = 0, cagnotteUse;
	int i;
	for (i=0; i<tlog; i++)
	{
		totalWeight += tabWeight[i] * tabQuantity[i];
		totalVolume += tabVolume[i] * tabQuantity[i];
		if (*priceConstraint != -1)
			totalPrice += tabUnitPrice[i] * tabQuantity[i];
		
		if (totalWeight > weightConstraint)
		{
			printf("Attention, la contrainte de charge maximale du véhicule a été dépassée de %.2f, veuillez retirer un article\n", totalWeight - weightConstraint);
			return -1;
		}
		if (totalVolume > volumeConstraint)
		{
			printf("Attention, la contrainte de volume maximum a été dépassé de %.2f, veuillez retirer un article\n", totalVolume - volumeConstraint); 
			return -1;
		}
		if (*priceConstraint != -1 && totalPrice > *priceConstraint)
		{
			printf("Attention, la contrainte de budget maximum a été dépassé de %.2f\n", totalPrice - *priceConstraint);
			if (*cagnotte < totalPrice)
			{
				printf("Le prix total excédant votre cagnotte, veuillez retirer un article\n");
				return -1;
			}
			else
			{
				printf("Vous pouvez utiliser votre cagnotte, dont le montant est de %.2f, entrez le montant à utiliser ou -1 si vous voulez retirer un article: ", *cagnotte);
				scanf("%f", &cagnotteUse);
				if (cagnotteUse == -1)
							return -1;
				while (cagnotteUse > *cagnotte || totalPrice-cagnotteUse > *priceConstraint)
				{
					if (cagnotteUse > *cagnotte)	
						printf("Erreur: vous ne pouvez pas utiliser plus que vous n'avez, réessayez ou entrer -1 si vous souhaitez retirer un article: ");
					if (totalPrice-cagnotteUse > *priceConstraint)
						printf("Erreur: vous n'avez pas utilisé assez de votre cagnotte, vous devez utiliser au moins %.2f, veuillez rentrer le montant à utiliser ou -1 si vous voulez retirer un article: ", totalPrice - *priceConstraint);
					scanf("%f", &cagnotteUse);
					if (cagnotteUse == -1)
						return -1;
					*cagnotte -= cagnotteUse;
					*priceConstraint += cagnotteUse;
				}
			}
		}
	}
	return 0;
}

/**
 * @brief Ajoute un article au panier et calcule les différents attributs pour la fonction `display_basket`
 * @param tab_reference: tableau des références des articles
 * @param weight: tableau des poids des articles
 * @param volume: tableau du volume des articles
 * @param unitPrice: tableau du prix unitaire des articles
 * @param cagnotte: pointeur indiquant la valeur de la cagnotte
 * @param basket_tab_ref: tableau des références du panier
 * @param basket_tab_qte: tableau de la quantité de l'article du panier
 * @param tlog: taille logique du tableau `tab_reference`
 * @param tlog_basket: taille logique du panier
 * @return taille logique du panier
*/
int basket_add (int tab_reference[], float weight[], float volume[], float unitPrice[], float *cagnotte, int  basket_tab_ref[], int basket_tab_qte[],int tlog, int tlog_basket)
{
	int ref_to_add, qte_to_add, trouve, index_ajout, i;
	float total_weight=0, total_volume=0, total_price=0, total_cagnotte=0;
	printf("Quelle référence souhaitez-vous ajouter au panier?");
	scanf("%d", &ref_to_add);
	index_ajout = searchTab(tab_reference, ref_to_add, tlog, &trouve);
	while (trouve == 0)
	{
		printf("L'élément que vous souhaitez ajouter n'existe pas, ressayez s'il vous plaît");
		scanf("%d", &ref_to_add);
		index_ajout = searchTab(tab_reference, ref_to_add, tlog, &trouve);
	}
	basket_tab_ref[index_ajout] = ref_to_add;
	printf("Quelle quantité de cet article souhaitez-vous ajouter au panier?");
	scanf("%d", &qte_to_add);
	while (qte_to_add <= 0)
	{
		printf("Vous ne pouvez pas ajouter une quantité nulle ou négative ressayez");
		scanf("%d", &qte_to_add);
	}
	basket_tab_qte[index_ajout] = ref_to_add;

	for (i=0; i<tlog_basket; i++)
	{
		index_ajout = basket_tab_ref[i];

		total_weight = total_weight + weight[index_ajout]*qte_to_add;
		total_volume = total_volume + volume[index_ajout]*qte_to_add;
		total_price = total_price + unitPrice[index_ajout]*qte_to_add;
	}
	*cagnotte = *cagnotte + *cagnotte*0.10;

	basket_add()

	tlog_basket = tlog_basket+1;
	return tlog_basket;
}